Index: /trunk/gli/src/org/greenstone/gatherer/cdm/IndexManager.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/IndexManager.java	(revision 4931)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/IndexManager.java	(revision 4932)
@@ -6,13 +6,7 @@
  * University of Waikato, New Zealand.
  *
- * <BR><BR>
- *
  * Author: John Thompson, Greenstone Digital Library, University of Waikato
  *
- * <BR><BR>
- *
  * Copyright (C) 1999 New Zealand Digital Library Project
- *
- * <BR><BR>
  *
  * This program is free software; you can redistribute it and/or modify
@@ -21,12 +15,8 @@
  * (at your option) any later version.
  *
- * <BR><BR>
- *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
- *
- * <BR><BR>
  *
  * You should have received a copy of the GNU General Public License
@@ -35,54 +25,21 @@
  *########################################################################
  */
-
- 
-
-
-
-
 package org.greenstone.gatherer.cdm;
-/**************************************************************************************
- * Title:        Gatherer
- * Description:  The Gatherer: a tool for gathering and enriching a digital collection.
- * Copyright:    Copyright (c) 2001
- * Company:      The University of Waikato
- * Written:      03/05/02
- * Revised:      17/11/02 - Commented
- **************************************************************************************/
-import java.awt.BorderLayout;
-import java.awt.Color;
-import java.awt.Component;
-import java.awt.Dimension;
-import java.awt.GridLayout;
-import java.awt.event.ActionEvent;
-import java.awt.event.ActionListener;
-import java.awt.event.KeyAdapter;
-import java.awt.event.KeyEvent;
-import java.util.Collections;
-import java.util.StringTokenizer;
-import java.util.Vector;
-import javax.swing.BorderFactory;
-import javax.swing.DefaultListCellRenderer;
-import javax.swing.DefaultListModel;
-import javax.swing.JButton;
-import javax.swing.JComboBox;
-import javax.swing.JLabel;
-import javax.swing.JList;
-import javax.swing.JOptionPane;
-import javax.swing.JPanel;
-import javax.swing.JScrollPane;
-import javax.swing.JTextArea;
-import javax.swing.JTextField;
-import javax.swing.event.ListDataEvent;
-import javax.swing.event.ListDataListener;
-import javax.swing.event.ListSelectionEvent;
-import javax.swing.event.ListSelectionListener;
+import java.awt.*;
+import java.awt.event.*;
+import java.util.*;
+import javax.swing.*;
+import javax.swing.event.*;
 import org.greenstone.gatherer.Gatherer;
+import org.greenstone.gatherer.cdm.CollectionMeta;
 import org.greenstone.gatherer.cdm.CommandTokenizer;
+import org.greenstone.gatherer.cdm.Control;
+import org.greenstone.gatherer.cdm.DOMProxyListModel;
 import org.greenstone.gatherer.cdm.Index;
 import org.greenstone.gatherer.msm.ElementWrapper;
 import org.greenstone.gatherer.msm.MSMUtils;
 import org.greenstone.gatherer.util.ExclusiveListSelectionListener;
-import org.w3c.dom.Element;
+import org.greenstone.gatherer.util.StaticStrings;
+import org.w3c.dom.*;
 /** This class is resposible for storing the indexes which have been assigned to this collection and the default index, and providing methods for interacting with both these data pools. It also knows how to turn itself into a String as it would be displayed in the collection configuration file.
  * @author John Thompson, Greenstone Digital Library, University of Waikato
@@ -90,251 +47,182 @@
  */
 public class IndexManager
-    extends DefaultListModel {
-    /** A reference to our creator, the collection design manager. */
-    private CollectionDesignManager manager = null;
+    extends DOMProxyListModel {
     /** The controls for editing the indexes. */
     private Control controls = null;
     /** A reference to ourselves so our inner methods have access. */
-    private DefaultListModel model = null;
-    /** A reference to the Gatherer, for access to the Dictionary and messaging purposes. */
-    private Gatherer gatherer = null;
+    private DOMProxyListModel model = null;
     /** The default index. */
     private Index default_index = null;
-    /** Constructor.
-     * @param gatherer A reference to the <strong>Gatherer</strong>.
-     * @param manager A reference to the <strong>CollectionDesignManager</strong>.
-     */
-    public IndexManager(Gatherer gatherer, CollectionDesignManager manager) {
-	super();
-	this.gatherer = gatherer;
-	this.manager = manager;
-	this.model = this;
+    /** Constructor. */
+    public IndexManager(Element indexes) {
+	super(indexes, CollectionConfiguration.INDEX_ELEMENT, new Index());
+	Gatherer.println("IndexManager: " + getSize() + " indexes parsed.");
+	model = this;
+	// Parse and retrieve the default index
+	NodeList default_index_elements = CollectionDesignManager.collect_config.getDocumentElement().getElementsByTagName(CollectionConfiguration.INDEX_DEFAULT_ELEMENT);
+	if(default_index_elements.getLength() > 0) {
+	    default_index = new Index((Element)default_index_elements.item(0));
+	}
     }
     /** Method to add a new index.
-	  * @param index The <strong>Index</strong> to add.
-	  * @see org.greenstone.gatherer.Gatherer
-	  * @see org.greenstone.gatherer.collection.CollectionManager
-	  */
-    public void addIndex(Index index) {
+     * @param index The <strong>Index</strong> to add.
+     * @see org.greenstone.gatherer.Gatherer
+     * @see org.greenstone.gatherer.collection.CollectionManager
+     */
+    public void addIndex(Index index, CollectionMeta metadatum) {
+	///ystem.err.println("Adding an index: " + index.toString());
 	if(!contains(index)) {
-	    String index_str = index.toString(false).toLowerCase();
-				// Add alphabetically.
-	    for(int i = 0; i < size(); i++) {
-		Index sibling = (Index) get(i);
-		String sibling_str = sibling.toString(false).toLowerCase();
-		int position = index_str.compareTo(sibling_str);
-		// Sibling is before index.
-		if(position > 0) {
-		    // Carry on.
-		}
-		// Index is equal to, or before sibling. Insert it.
-		else if(position == 0 || position < 0) {
-		    add(i, index);
-		    gatherer.c_man.configurationChanged();
-		    return;
-		}
-	    }
-				// If we got this far, we haven't inserted index, and we are out of model so.
-	    addElement(index);
-	    gatherer.c_man.configurationChanged();
+	    CollectionDesignManager.collectionmeta_manager.addMetadatum(metadatum);
+	    // Retrieve the currently last index
+	    Index last_index = (Index)getElementAt(getSize() - 1);
+	    addAfter(index, last_index);
+	    Gatherer.c_man.configurationChanged();
 	}
 	else {
-	    JOptionPane.showMessageDialog(manager.gui, get("CDM.IndexManager.Index_Exists"), get("General.Warning"), JOptionPane.WARNING_MESSAGE);
-	}
-    }
-    /** Method to acquire the controls for editing the indexes.
-	  * @return A <strong>JPanel</strong> containing the controls.
-	  * @see org.greenstone.gatherer.cdm.IndexManager.Control
-	  */
-    public JPanel getControls() {
-	if(controls == null) {
-	    controls = new Control();
-	}
-	return controls;
-    }
-    /** Method to get the default index.
-	  * @return The default <strong>Index</strong>.
-	  */
-    public Index getDefault() {
-	return default_index;
-    }
-    /** Method to retrieve a certain index, as referenced by an index number.
-	  * @param index An <i>int</i> which indicates the position of the desired index.
-	  * @return The <strong>Index</strong> at the given index, or <i>null</i> if no such index exists.
-	  */
-    public Index getIndex(int index) {
-	if(0 <= index && index < size()) {
-	    return (Index)get(index);
-	}
-	return null;
-    }
-    /** Method to retrieve a certain index, given its name.
-	  * @param name The name of the index as a <Strong>String</strong>.
-	  * @return The <strong>Index</strong> that matches name, or <i>null</i> if no such index exists.
-	  */
-    public Index getIndex(String name) {
-	///ystem.err.println("Searching for index " + name);
-	for(int i = 0; i < size(); i++) {
-	    Index index = (Index) get(i);
-	    if(index.toString(false).equals(name)) {
-		///ystem.err.println("Found.");
-		return (Index)get(i);
-	    }
-	}
-	///ystem.err.println("No such index.");
-	return null;
-    }
-    /** A method to retrieve all of the indexes associated with this manager.
-	  * @return A <strong>Vector</strong> of <strong>Index</strong>es.
-	  */
-    public Vector getIndexes() {
-	Vector indexes = new Vector();
-	for(int i = 0; i < size(); i++) {
-	    indexes.add(get(i));
-	}
-	Collections.sort(indexes);
-	return indexes;
-    }
-    /** Mark the current set of controls, if any, as obsolete and deallocate them. If further need of the controls will cause new controls to be created.
-	* @see org.greenstone.gatherer.cdm.IndexManager.Control
-	*/
-    public void invalidateControls() {
+	    JOptionPane.showMessageDialog(Gatherer.g_man, get("CDM.IndexManager.Index_Exists"), get("General.Warning"), JOptionPane.WARNING_MESSAGE);
+	}
+    }
+
+    public void destroy() {
 	if(controls != null) {
 	    controls.destroy();
-	}
-	controls = null;
-    }
-    /** Method that attempts to parse an index related command from the given command. If such a command is parsed, it is immediately registered with this manager.
-	  * @param command The <strong>String</strong> to parse.
-	  * @return A <i>boolean</i> which is <i>true</i> if a command was parsed, <i>false</i> otherwise.
-	  * @see org.greenstone.gatherer.cdm.CommandTokenizer
-	  * @see org.greenstone.gatherer.cdm.Index
-	  */
-    public boolean parse(String command) {
-	String temp = command.toLowerCase();
-	if(temp.startsWith("indexes")) {
-	    CommandTokenizer ct = new CommandTokenizer(command);
-	    ct.nextToken(); // Throw away indexes.
-	    while(ct.hasMoreTokens()) {
-		String entry = ct.nextToken();
-		Index index = Index.parseIndexConfig(entry, manager);
-		if (index != null) {
-		    addIndex(index);
-		    
-		} else { // return false if there is one error??
-		    return false;
-		}
-	    }
-	    
-	    return true;
-	}
-	else if(temp.startsWith("defaultindex")) {
-	    CommandTokenizer ct = new CommandTokenizer(command);
-	    ct.nextToken();
-	    String entry = ct.nextToken();
-	    Index index = Index.parseIndexConfig(entry, manager);
-	    if (index != null) {
-		setDefault(index);
-		return true;
-	    } 
-	    return false;
-	}
-	
-	return false;
-    }
-
-    public void removeAll() {
-	removeAllElements();
+	    controls = null;
+	}
 	default_index = null;
-	gatherer.c_man.configurationChanged();
+	model = null;
+    }
+
+    /** Method to acquire the controls for editing the indexes.
+     * @return the Control
+     */
+    public Control getControls() {
+	if(controls == null) {
+	    // Build controls
+	    controls = new IndexControl();
+	}
+	return controls;
+    }
+
+    /** Method to get the default index.
+     * @return The default <strong>Index</strong>.
+     */
+    public Index getDefault() {
+	if(default_index != null && default_index.isAssigned()) {
+	    return default_index;
+	}
+	else {
+	    return null;
+	}
+    }
+
+    /** Method to retrieve a certain index, as referenced by an index number.
+     * @param index An <i>int</i> which indicates the position of the desired index.
+     * @return The <strong>Index</strong> at the given index, or <i>null</i> if no such index exists.
+     */
+    public Index getIndex(int index) {
+	if(0 <= index && index < getSize()) {
+	    return (Index)getElementAt(index);
+	}
+	return null;
+    }
+
+    /** Method to retrieve a certain index, given its id.
+     * @param id the id of the index as a String
+     * @return the Index that matches id, or null if no such index exists
+     */
+    public Index getIndex(String id) {
+	int size = getSize();
+	for(int i = 0; i < size; i++) {
+	    Index index = (Index) getElementAt(i);
+	    if(index.getID().equals(id)) {
+		return index;
+	    }
+	}
+	return null;
+    }
+
+    public ArrayList getIndexes() {
+	return children();
     }
 
     /** Method to remove a certain index.
-	  * @param index The <Strong>Index</strong> to remove.
-	  * @see org.greenstone.gatherer.Gatherer
-	  * @see org.greenstone.gatherer.cdm.CollectionDesignManager
-	  * @see org.greenstone.gatherer.cdm.CollectionMetaManager
-	  * @see org.greenstone.gatherer.collection.CollectionManager
-	  */
+     * @param index the Index to remove.
+     * @see org.greenstone.gatherer.Gatherer
+     * @see org.greenstone.gatherer.cdm.CollectionDesignManager
+     * @see org.greenstone.gatherer.cdm.CollectionMetaManager
+     * @see org.greenstone.gatherer.collection.CollectionManager
+     */
     public void removeIndex(Index index) {
 	if(index != null) {
-	    String name = index.getName();
-	    if(name != null) {
-		Language default_language = manager.languages.getDefaultLanguage();
-		CollectionMeta metadata = new CollectionMeta(manager, index, default_language, name);
-		manager.collectionmetadatum.removeMetadata(metadata);
-	    }
-	    removeElement(index);
+	    // Remove any current metadata from this index
+	    CollectionDesignManager.collectionmeta_manager.removeMetadata(StaticStrings.STOP_CHARACTER + index.getID());
+	    // Check if the index removed happens to be the default index
 	    if(default_index != null && default_index.equals(index)) {
-		default_index = null;
-	    }
-	    gatherer.c_man.configurationChanged();
-	}
-    }
+		default_index.setAssigned(false);
+	    }
+	    // Remove the index
+	    remove(index);
+	    Gatherer.c_man.configurationChanged();
+	}
+    }
+
     /** Method to set the default index.
-	  * @param index The new default <strong>Index</strong>.
-	  * @see org.greenstone.gatherer.Gatherer
-	  * @see org.greenstone.gatherer.collection.CollectionManager
-	  */
+     * @param index the new default Index
+     * @see org.greenstone.gatherer.Gatherer
+     * @see org.greenstone.gatherer.collection.CollectionManager
+     */
     public void setDefault(Index index) {
-	default_index = index;
-	if(index != null && !contains(index)) {
-	    addElement(index);
-	}
-	gatherer.c_man.configurationChanged();
-    }
-    /** Method to print out the contents of this class as a string.
-	  * @return A <strong>String</strong> just as it would appear in the colleciton configuration file.
-	  */
-    public String toString() {
-	String text = "";
-	// First the indexes.
-	if(size() > 0) {
-	    text = "indexes      ";
-	    for(int i = 0; i < size(); i++) {
-		Index index = (Index) get(i);
-		text = text + index.toStringConfig();
-		if(i < size() - 1) {
-		    text = text + " ";
-		}
-	    }
-	    // Now the default index if there is one, or just the first index
-	    // if there isn't
+	if(index != null) {
+	    if(default_index == null) {
+		// Create the default index element, and place immediately after indexes element.
+		Element default_index_element = root.getOwnerDocument().createElement(CollectionConfiguration.INDEX_DEFAULT_ELEMENT);
+		default_index = new Index(default_index_element);
+		Node target_node = CollectionConfiguration.findInsertionPoint(default_index_element);
+		if(target_node != null) {
+		    root.getOwnerDocument().getDocumentElement().insertBefore(default_index_element, target_node);
+		}
+		else {
+		    root.getOwnerDocument().getDocumentElement().appendChild(default_index_element);
+		}
+	    }
+	    default_index.setAssigned(true);
+	    default_index.setLevel(index.getLevel());
+	    default_index.setSources(index.getSources());
+	}
+	else {
 	    if(default_index != null) {
-		text = text + "\ndefaultindex " + default_index.toStringConfig() + "\n";
-	    }
-	    text = text + "\n";
-	}
-	return text;
-    }
-
-
-
-
+		default_index.setAssigned(false);
+	    }
+	}
+	Gatherer.c_man.configurationChanged();
+    }
     
     /** Overloaded to call get with both a key and an empty argument array.
-	  * @param key A <strong>String</strong> which is mapped to a initial String within the ResourceBundle.
-	  * @return A <strong>String</strong> which has been referenced by the key String and that either contains no argument fields, or has had the argument fields automatiically populated with formatting Strings of with argument String provided in the get call.
-	  */
+     * @param key A <strong>String</strong> which is mapped to a initial String within the ResourceBundle.
+     * @return A <strong>String</strong> which has been referenced by the key String and that either contains no argument fields, or has had the argument fields automatiically populated with formatting Strings of with argument String provided in the get call.
+     */
     private String get(String key) {
 	return get(key, null);
     }
+
     /** Used to retrieve a property value from the Locale specific ResourceBundle, based upon the key and arguments supplied. If the key cannot be found or if some other part of the call fails a default (English) error message is returned. <BR>
-	  * Here the get recieves a second argument which is an array of Strings used to populate argument fields, denoted {<I>n</I>}, within the value String returned. Note that argument numbers greater than or equal to 32 are automatically mapped to the formatting String named Farg<I>n</I>.
-	  * @param key A <strong>String</strong> which is mapped to a initial String within the ResourceBundle.
-	  * @param args A <strong>String[]</strong> used to populate argument fields within the complete String.
-	  * @return A <strong>String</strong> which has been referenced by the key String and that either contains no argument fields, or has had the argument fields automatiically populated with formatting Strings of with argument String provided in the get call.
-	  * @see org.greenstone.gatherer.Gatherer
-	  * @see org.greenstone.gatherer.Dictionary
-	  */
+     * Here the get recieves a second argument which is an array of Strings used to populate argument fields, denoted {<I>n</I>}, within the value String returned. Note that argument numbers greater than or equal to 32 are automatically mapped to the formatting String named Farg<I>n</I>.
+     * @param key A <strong>String</strong> which is mapped to a initial String within the ResourceBundle.
+     * @param args A <strong>String[]</strong> used to populate argument fields within the complete String.
+     * @return A <strong>String</strong> which has been referenced by the key String and that either contains no argument fields, or has had the argument fields automatically populated with formatting Strings of with argument String provided in the get call.
+     * @see org.greenstone.gatherer.Gatherer
+     * @see org.greenstone.gatherer.Dictionary
+     */
     private String get(String key, String args[]) {
 	if(key.indexOf('.') == -1) {
 	    key = "CDM.IndexManager." + key;
 	}
-	return gatherer.dictionary.get(key, args);
-    }
+	return Gatherer.dictionary.get(key, args);
+    }
+
     /** This class creates a set of controls for editing the indexes. */
-    private class Control
-	extends JPanel {
+    private class IndexControl
+	extends JPanel 
+	implements Control {
 	/** The default size of a label on this control. */
 	private Dimension LABEL_SIZE = new Dimension(120,25);
@@ -406,10 +294,9 @@
 	 * @see org.greenstone.gatherer.util.ExclusiveListSelectionListener
 	 */
-	public Control() {
+	public IndexControl() {
 	    super();
 	    source_model = new Vector();
 	    source_model.add("text");
-	    source_model.addAll(gatherer.c_man.msm.getAssignedElements());
-	    //source_model.addAll(gatherer.c_man.msm.getElements());
+	    source_model.addAll(Gatherer.c_man.getCollection().msm.getAssignedElements());
 	    // Creation
 	    add = new JButton(get("Add"));
@@ -428,5 +315,5 @@
 	    default_pane = new JPanel();
 	    if(default_index != null) {
-		default_value = new JTextField(default_index.toString(true));
+		default_value = new JTextField(default_index.toString());
 		default_value.setCaretPosition(0);
 	    }
@@ -440,5 +327,4 @@
 	    index_label = new JLabel(get("Indexes"));
 	    index_list = new JList(model);
-	    index_list.setCellRenderer(new IndexListCellRenderer());
 	    instructions = new JTextArea(get("Instructions"));
 	    instructions.setEditable(false);
@@ -550,13 +436,9 @@
 	}
 	/* Destructor, removes persistant listeners from the Dictionary.
-			*/
+	 */
 	public void destroy() {
 	}
-	/** We override the updateUI method so that we can ensure we are scrolled to the top of the instructions box first.
-		  * @see org.greenstone.gatherer.Gatherer
-		  * @see org.greenstone.gatherer.collection.CollectionManager
-		  * @see org.greenstone.gatherer.msm.MetadataSetManager
-			*/
-	public void updateUI() {
+
+	public void gainFocus() {
 	    if(instructions != null) {
 		instructions.setCaretPosition(0);
@@ -566,12 +448,14 @@
 		source_model.clear();
 		source_model.add("text");
-		source_model.addAll(gatherer.c_man.msm.getAssignedElements());
+		source_model.addAll(Gatherer.c_man.getCollection().msm.getAssignedElements());
 		// reset the model in the list - needed if the model is larger than when it was first created, the list doesn't display
 		source_list.setListData(source_model);
 	    
 	    }
-	    // Faster than a NPE its the - 'Super class'.
-	    super.updateUI();
-	}
+	}
+
+	public void loseFocus() {
+	}
+
 	/** Listens for actions apon the 'add' button in the IndexManager controls, and if detected calls the add method of the manager with a newly created index. */
 	private class AddListener
@@ -589,15 +473,18 @@
 		if(!source_list.isSelectionEmpty() && name.getText().length() != 0) {
 		    Object object[] = source_list.getSelectedValues();
-		    Vector sources = new Vector();
+		    ArrayList sources = new ArrayList();
 		    for(int i = 0; i < object.length; i++) {
 			sources.add(object[i]);
 		    }
-		    Index index = new Index(level.getSelectedIndex(), sources, manager);
+		    object = null;
+		    Index index = new Index(level.getSelectedIndex(), sources);
+		    sources = null;
 		    // Before we add the index to the model, we have to add the collection metadata for this.
-		    Language language = manager.languages.getDefaultLanguage();
-		    CollectionMeta metadata = new CollectionMeta(manager, index, language, name.getText());
-		    manager.collectionmetadatum.addMetadata(metadata);
+		    CollectionMeta metadatum = new CollectionMeta(StaticStrings.STOP_CHARACTER + index.getID());
+		    metadatum.setValue(name.getText());
 		    // Finally add index.
-		    addIndex(index);
+		    addIndex(index, metadatum);
+		    metadatum = null;
+		    index = null;
 		}
 	    }
@@ -606,7 +493,7 @@
 	private class ClearDefaultListener
 	    implements ActionListener {
-				/** If called when an action occurs on a registered component, we clear the default index.
-				 * @param event An <strong>ActionEvent</strong> containing extra information about the action that occured.
-				*/
+	    /** If called when an action occurs on a registered component, we clear the default index.
+	     * @param event An <strong>ActionEvent</strong> containing extra information about the action that occured.
+	     */
 	    public void actionPerformed(ActionEvent event) {
 		setDefault(null);
@@ -643,5 +530,5 @@
 		if(default_index != null) {
 		    clear_default.setEnabled(true);
-		    default_value.setText(default_index.toString(true));
+		    default_value.setText(default_index.toString());
 		    default_value.setCaretPosition(0);
 		}
@@ -698,23 +585,4 @@
 	    }
 	}
-
-
-	private class IndexListCellRenderer
-	    extends DefaultListCellRenderer {
-	    
-	    public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
-		StringBuffer text = new StringBuffer(value.toString());
-		// Retrieve the indexes name if any.
-		CollectionMeta metadata = manager.collectionmetadatum.getMetadata(value, manager.languages.getDefaultLanguage(), true);
-		if(metadata != null) {
-		    text.append(" \"");
-		    text.append(metadata.getValue());
-		    text.append("\"");
-		}
-		return super.getListCellRendererComponent(list, text.toString(), index, isSelected, cellHasFocus);
-	    }
-
-	}
-
     }
 }
Index: /trunk/gli/src/org/greenstone/gatherer/cdm/Language.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/Language.java	(revision 4931)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/Language.java	(revision 4932)
@@ -6,13 +6,7 @@
  * University of Waikato, New Zealand.
  *
- * <BR><BR>
- *
  * Author: John Thompson, Greenstone Digital Library, University of Waikato
  *
- * <BR><BR>
- *
  * Copyright (C) 1999 New Zealand Digital Library Project
- *
- * <BR><BR>
  *
  * This program is free software; you can redistribute it and/or modify
@@ -21,12 +15,8 @@
  * (at your option) any later version.
  *
- * <BR><BR>
- *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
- *
- * <BR><BR>
  *
  * You should have received a copy of the GNU General Public License
@@ -35,20 +25,15 @@
  *########################################################################
  */
-
- 
-
-
-
-
 package org.greenstone.gatherer.cdm;
 /**************************************************************************************
- * Title:        Gatherer
- * Description:  The Gatherer: a tool for gathering and enriching a digital collection.
- * Copyright:    Copyright (c) 2001
- * Company:      The University of Waikato
  * Written:      08/05/02
  * Revised:      17/11/02 - Commented
+ *               07/07/03 - DOM support
  **************************************************************************************/
-
+import org.greenstone.gatherer.cdm.CollectionConfiguration;
+import org.greenstone.gatherer.cdm.CollectionDesignManager;
+import org.greenstone.gatherer.cdm.DOMProxyListEntry;
+import org.greenstone.gatherer.msm.MSMUtils;
+import org.w3c.dom.*;
 /** A pretty unexciting extension of a two character string, in that it has a field which details if its the default language.
 * @author John Thompson, Greenstone Digital Library, University of Waikato
@@ -56,70 +41,101 @@
 */
 public class Language
-    implements Comparable {
-    /** Is this language the default one. */
-    private boolean default_language = false;
+    implements Comparable, DOMProxyListEntry {
+    /** The Element this language entry is based upon. */
+    private Element element = null;
+    /** The two character code for this language. */
+    private String code = null;
     /** The name of this language. */
     private String name = null;
-    /** The two character code for this language. */
-    private String value = null;
-    /** Constructor.
-     * @param value A <strong>String</strong> representing the code for this language.
-     * @param name A <strong>String</strong> representing the name of this language.
-     * @param default_language A <i>boolean</i> which is <i>true</i> if this language is the default one.
-	  */
-    public Language(String value, String name, boolean default_language) {
-	this.default_language = default_language;
-	this.name = name;
-	this.value = value.substring(0, 2);
+ 
+    public Language() {
     }
-    /** Copy constructor.
-	  * @param language The <strong>Language</strong> we want to copy.
-	  */
-    public Language(Language language) {
-	this.default_language = language.isDefault();
-	this.name = language.toString();
-	this.value = language.getCode();
+
+    public Language(Element element) {
+	this.element = element;
     }
+
+    /** Constructor for a brand new language. */
+    public Language(String code) {
+	this.code = code;
+	// Create the new element
+	element = CollectionDesignManager.collect_config.document.createElement(CollectionConfiguration.LANGUAGE_ELEMENT);
+	element.setAttribute(CollectionConfiguration.NAME_ATTRIBUTE, code);
+	element.setAttribute(CollectionConfiguration.ASSIGNED_ATTRIBUTE, CollectionConfiguration.TRUE_STR);
+    }
+
     /** Method to compare two languages for ordering purposes.
-	  * @param object The other language as an <strong>Object</strong>.
-	  * @return An <i>int</i> which indicates order using the same values as in String.compareTo().
-	  * @see java.lang.String#compareTo
-	  */
+     * @param object the other language as an Object
+     * @return an int which indicates the order between this language and the given one: < 0, 0 or > 0 for before, equal to or after respectively
+     */
     public int compareTo(Object object) {
 	return toString().compareTo(object.toString());
     }
+
+    public DOMProxyListEntry create(Element element) {
+	return new Language(element);
+    }
+
     /** Method to test for the equality of two languages.
-	  * @param object The other language as an <strong>Object</strong>.
-	  * @return <i>true</i> if the languages are equal, <i>false</i> otherwise.
-	  */
+     * @param object The other language as an <strong>Object</strong>.
+     * @return <i>true</i> if the languages are equal, <i>false</i> otherwise.
+     */
     public boolean equals(Object object) {
-	if(compareTo(object) == 0) {
-	    return true;
+	return (compareTo(object) == 0);
+    }
+
+    /** Method to retrieve the code of this language.
+     * @return A <strong>String</strong> representing the two letter code.
+     */
+    public String getCode() {
+	if(code == null && element != null) {
+	    code = element.getAttribute(CollectionConfiguration.NAME_ATTRIBUTE);
 	}
-	return false;
+	return code;
     }
-    /** Method to retrieve the code of this language.
-	  * @return A <strong>String</strong> representing the two letter code.
-	  */
-    public String getCode() {
-	return value;
+
+    public Element getElement() {
+	return element;
     }
-    /** Method to determine if this language is the default one.
-	  * @return A <i>boolean</i> which is <i>true</i> if this language is the default one.
-	  */
-    public boolean isDefault() {
-	return default_language;
+
+    public String getName() {
+	if(name == null) {
+	    String code = getCode();
+	    name = CollectionDesignManager.language_manager.getLanguageName(code);
+	}
+	return name;
     }
-    /** Method to set the value of default.
-	  * @param value The new value of default as a <i>boolean</i>.
-	  */
-    public void setDefault(boolean value) {
-	this.default_language = default_language;
+
+    public boolean isAssigned() {
+	return (element != null && element.getAttribute(CollectionConfiguration.ASSIGNED_ATTRIBUTE).equals(CollectionConfiguration.TRUE_STR));
     }
+
+    public void setAssigned(boolean value) {
+	if(element != null) {
+	    element.setAttribute(CollectionConfiguration.ASSIGNED_ATTRIBUTE, (value ? CollectionConfiguration.TRUE_STR : CollectionConfiguration.FALSE_STR));
+	}
+    }
+
+    public void setCode(String new_code) {
+	code = new_code;
+	// Set element
+	if(element != null) {
+	    element.setAttribute(CollectionConfiguration.NAME_ATTRIBUTE, new_code);
+	}
+	// Reset name
+	name = null;
+    }
+
+    public void setElement(Element new_element) {
+	element = new_element;
+	code = null;
+	name = null;
+    }
+
     /** Method to display the language code.
-	  * @return A <strong>String</strong> representing the language code.
-	  */
+     * @return A <strong>String</strong> representing the language code.
+     */
     public String toString() {
-	return name;
+	return getName();
     }
 }
